// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"go.phucam.tv/ent/predicate"
	"go.phucam.tv/ent/user"
	"go.phucam.tv/ent/userpassword"
)

// UserPasswordQuery is the builder for querying UserPassword entities.
type UserPasswordQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.UserPassword
	// eager-loading edges.
	withUser *UserQuery
	withFKs  bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the UserPasswordQuery builder.
func (upq *UserPasswordQuery) Where(ps ...predicate.UserPassword) *UserPasswordQuery {
	upq.predicates = append(upq.predicates, ps...)
	return upq
}

// Limit adds a limit step to the query.
func (upq *UserPasswordQuery) Limit(limit int) *UserPasswordQuery {
	upq.limit = &limit
	return upq
}

// Offset adds an offset step to the query.
func (upq *UserPasswordQuery) Offset(offset int) *UserPasswordQuery {
	upq.offset = &offset
	return upq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (upq *UserPasswordQuery) Unique(unique bool) *UserPasswordQuery {
	upq.unique = &unique
	return upq
}

// Order adds an order step to the query.
func (upq *UserPasswordQuery) Order(o ...OrderFunc) *UserPasswordQuery {
	upq.order = append(upq.order, o...)
	return upq
}

// QueryUser chains the current query on the "user" edge.
func (upq *UserPasswordQuery) QueryUser() *UserQuery {
	query := &UserQuery{config: upq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := upq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := upq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(userpassword.Table, userpassword.FieldID, selector),
			sqlgraph.To(user.Table, user.FieldID),
			sqlgraph.Edge(sqlgraph.O2O, true, userpassword.UserTable, userpassword.UserColumn),
		)
		fromU = sqlgraph.SetNeighbors(upq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first UserPassword entity from the query.
// Returns a *NotFoundError when no UserPassword was found.
func (upq *UserPasswordQuery) First(ctx context.Context) (*UserPassword, error) {
	nodes, err := upq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{userpassword.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (upq *UserPasswordQuery) FirstX(ctx context.Context) *UserPassword {
	node, err := upq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first UserPassword ID from the query.
// Returns a *NotFoundError when no UserPassword ID was found.
func (upq *UserPasswordQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = upq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{userpassword.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (upq *UserPasswordQuery) FirstIDX(ctx context.Context) int {
	id, err := upq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single UserPassword entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one UserPassword entity is found.
// Returns a *NotFoundError when no UserPassword entities are found.
func (upq *UserPasswordQuery) Only(ctx context.Context) (*UserPassword, error) {
	nodes, err := upq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{userpassword.Label}
	default:
		return nil, &NotSingularError{userpassword.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (upq *UserPasswordQuery) OnlyX(ctx context.Context) *UserPassword {
	node, err := upq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only UserPassword ID in the query.
// Returns a *NotSingularError when more than one UserPassword ID is found.
// Returns a *NotFoundError when no entities are found.
func (upq *UserPasswordQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = upq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{userpassword.Label}
	default:
		err = &NotSingularError{userpassword.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (upq *UserPasswordQuery) OnlyIDX(ctx context.Context) int {
	id, err := upq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of UserPasswords.
func (upq *UserPasswordQuery) All(ctx context.Context) ([]*UserPassword, error) {
	if err := upq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return upq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (upq *UserPasswordQuery) AllX(ctx context.Context) []*UserPassword {
	nodes, err := upq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of UserPassword IDs.
func (upq *UserPasswordQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := upq.Select(userpassword.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (upq *UserPasswordQuery) IDsX(ctx context.Context) []int {
	ids, err := upq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (upq *UserPasswordQuery) Count(ctx context.Context) (int, error) {
	if err := upq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return upq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (upq *UserPasswordQuery) CountX(ctx context.Context) int {
	count, err := upq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (upq *UserPasswordQuery) Exist(ctx context.Context) (bool, error) {
	if err := upq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return upq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (upq *UserPasswordQuery) ExistX(ctx context.Context) bool {
	exist, err := upq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the UserPasswordQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (upq *UserPasswordQuery) Clone() *UserPasswordQuery {
	if upq == nil {
		return nil
	}
	return &UserPasswordQuery{
		config:     upq.config,
		limit:      upq.limit,
		offset:     upq.offset,
		order:      append([]OrderFunc{}, upq.order...),
		predicates: append([]predicate.UserPassword{}, upq.predicates...),
		withUser:   upq.withUser.Clone(),
		// clone intermediate query.
		sql:    upq.sql.Clone(),
		path:   upq.path,
		unique: upq.unique,
	}
}

// WithUser tells the query-builder to eager-load the nodes that are connected to
// the "user" edge. The optional arguments are used to configure the query builder of the edge.
func (upq *UserPasswordQuery) WithUser(opts ...func(*UserQuery)) *UserPasswordQuery {
	query := &UserQuery{config: upq.config}
	for _, opt := range opts {
		opt(query)
	}
	upq.withUser = query
	return upq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		HashedValue string `json:"hashedValue,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.UserPassword.Query().
//		GroupBy(userpassword.FieldHashedValue).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (upq *UserPasswordQuery) GroupBy(field string, fields ...string) *UserPasswordGroupBy {
	grbuild := &UserPasswordGroupBy{config: upq.config}
	grbuild.fields = append([]string{field}, fields...)
	grbuild.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := upq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return upq.sqlQuery(ctx), nil
	}
	grbuild.label = userpassword.Label
	grbuild.flds, grbuild.scan = &grbuild.fields, grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		HashedValue string `json:"hashedValue,omitempty"`
//	}
//
//	client.UserPassword.Query().
//		Select(userpassword.FieldHashedValue).
//		Scan(ctx, &v)
//
func (upq *UserPasswordQuery) Select(fields ...string) *UserPasswordSelect {
	upq.fields = append(upq.fields, fields...)
	selbuild := &UserPasswordSelect{UserPasswordQuery: upq}
	selbuild.label = userpassword.Label
	selbuild.flds, selbuild.scan = &upq.fields, selbuild.Scan
	return selbuild
}

func (upq *UserPasswordQuery) prepareQuery(ctx context.Context) error {
	for _, f := range upq.fields {
		if !userpassword.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if upq.path != nil {
		prev, err := upq.path(ctx)
		if err != nil {
			return err
		}
		upq.sql = prev
	}
	return nil
}

func (upq *UserPasswordQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*UserPassword, error) {
	var (
		nodes       = []*UserPassword{}
		withFKs     = upq.withFKs
		_spec       = upq.querySpec()
		loadedTypes = [1]bool{
			upq.withUser != nil,
		}
	)
	if upq.withUser != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, userpassword.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		return (*UserPassword).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		node := &UserPassword{config: upq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, upq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := upq.withUser; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*UserPassword)
		for i := range nodes {
			if nodes[i].user_password == nil {
				continue
			}
			fk := *nodes[i].user_password
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(user.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "user_password" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.User = n
			}
		}
	}

	return nodes, nil
}

func (upq *UserPasswordQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := upq.querySpec()
	_spec.Node.Columns = upq.fields
	if len(upq.fields) > 0 {
		_spec.Unique = upq.unique != nil && *upq.unique
	}
	return sqlgraph.CountNodes(ctx, upq.driver, _spec)
}

func (upq *UserPasswordQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := upq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (upq *UserPasswordQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   userpassword.Table,
			Columns: userpassword.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: userpassword.FieldID,
			},
		},
		From:   upq.sql,
		Unique: true,
	}
	if unique := upq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := upq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, userpassword.FieldID)
		for i := range fields {
			if fields[i] != userpassword.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := upq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := upq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := upq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := upq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (upq *UserPasswordQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(upq.driver.Dialect())
	t1 := builder.Table(userpassword.Table)
	columns := upq.fields
	if len(columns) == 0 {
		columns = userpassword.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if upq.sql != nil {
		selector = upq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if upq.unique != nil && *upq.unique {
		selector.Distinct()
	}
	for _, p := range upq.predicates {
		p(selector)
	}
	for _, p := range upq.order {
		p(selector)
	}
	if offset := upq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := upq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// UserPasswordGroupBy is the group-by builder for UserPassword entities.
type UserPasswordGroupBy struct {
	config
	selector
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (upgb *UserPasswordGroupBy) Aggregate(fns ...AggregateFunc) *UserPasswordGroupBy {
	upgb.fns = append(upgb.fns, fns...)
	return upgb
}

// Scan applies the group-by query and scans the result into the given value.
func (upgb *UserPasswordGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := upgb.path(ctx)
	if err != nil {
		return err
	}
	upgb.sql = query
	return upgb.sqlScan(ctx, v)
}

func (upgb *UserPasswordGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range upgb.fields {
		if !userpassword.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := upgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := upgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (upgb *UserPasswordGroupBy) sqlQuery() *sql.Selector {
	selector := upgb.sql.Select()
	aggregation := make([]string, 0, len(upgb.fns))
	for _, fn := range upgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(upgb.fields)+len(upgb.fns))
		for _, f := range upgb.fields {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(upgb.fields...)...)
}

// UserPasswordSelect is the builder for selecting fields of UserPassword entities.
type UserPasswordSelect struct {
	*UserPasswordQuery
	selector
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (ups *UserPasswordSelect) Scan(ctx context.Context, v interface{}) error {
	if err := ups.prepareQuery(ctx); err != nil {
		return err
	}
	ups.sql = ups.UserPasswordQuery.sqlQuery(ctx)
	return ups.sqlScan(ctx, v)
}

func (ups *UserPasswordSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := ups.sql.Query()
	if err := ups.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
